// p2idemo.cpp : Defines the class behaviors for the application.
//           P2IDEMO is a simple program which consists of a main window
//           and an "About" dialog which can be invoked by a menu choice.
//           It is intended to serve as a starting-point for new
//           applications.
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and Microsoft
// WinHelp documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "resource.h"

#include "p2idemo.h"
#include "p2i32rc.h"

#include "winxext.h"

UINT uiPAM_IMAGE_CREATED;

HINSTANCE g_hInst = NULL;


/////////////////////////////////////////////////////////////////////////////

// theApp:
// Just creating this application object runs the whole application.
//
CTheApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////

// CMainWindow constructor:
// Create the window with the appropriate style, size, menu, etc.
//
CMainWindow::CMainWindow()
{
  TCHAR szDefault[100];
  TCHAR szAppEvent[100];

	LoadFrame(IDR_MAINFRAME);

	lstrcpy(szDefault, TEXT("no message found"));

  GetPrivateProfileString(TEXT("PrintModeOptions"), TEXT("Mode-2-AppEvent"), szDefault, szAppEvent, sizeof(szAppEvent), TEXT("p2image.ini"));

  //MessageBoxA(szAppEvent, TEXT("P-2-I CMainWindow"), MB_OK);

	uiPAM_IMAGE_CREATED = RegisterWindowMessage(szAppEvent);
}

// OnPaint:
// This routine draws the string  in the center of the
// client area.  It is called whenever Windows sends a WM_PAINT message.
// Note that creating a CPaintDC automatically does a BeginPaint and
// an EndPaint call is done when it is destroyed at the end of this
// function.  CPaintDC's constructor needs the window (this).
//

void cdecl Error(LPSTR lpFormat, ...) 
{
    TCHAR szTempBuf[500];
	  TCHAR szTitle [100];
		HWND hdlg;

    LoadString(g_hInst, IDR_MAINFRAME, szTitle, ARRAY_COUNT(szTitle) );

    wvsprintf(szTempBuf, lpFormat, (LPTSTR)(&lpFormat+1));
    MessageBeep(MB_ICONEXCLAMATION);
		hdlg = GetActiveWindow();  
    MessageBox(hdlg, szTempBuf, szTitle, MB_OK|MB_ICONEXCLAMATION);
    
} 


LONG CMainWindow::OnUserTrapped(UINT wParam, LONG lParam)
{

  static HANDLE s_hFileMap = NULL;
	TCHAR szDefault[_MAX_PATH];	
	TCHAR szFilename[_MAX_PATH];
	int iResult;

  //MessageBoxA("test", TEXT("P-2-I OnUserTrapped"), MB_OK);
	 	

	lstrcpy(szDefault,"");

	SetForegroundWindow();

  iResult = GetPrivateProfileString(TEXT("Output"), TEXT("LastFileName"), szDefault, szFilename, sizeof(szFilename), TEXT("p2image.ini"));
	if (iResult == 0)
		  MessageBoxA(szFilename, TEXT("P-2-I Registered Message trapped. LastFileName is blank"), MB_OK);
	else
		  MessageBoxA(szFilename, TEXT("P-2-I Registered Message trapped. LastFileName = "), MB_OK);

	return lParam;
	
}
void CMainWindow::OnPaint()
{
	CRect rect;
	GetClientRect(rect);

	CPaintDC dc(this);
	dc.SetTextAlign(TA_BASELINE | TA_CENTER);
	dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkMode(TRANSPARENT);
	CString s;
	s.LoadString(IDS_HELLO);
	dc.TextOut((rect.right / 2), (rect.bottom / 2), s);
}

// OnAbout:
// This member function is called when a WM_COMMAND message with an
// ID_APP_ABOUT code is received by the CMainWindow class object.   The
// message map below is responsible for this routing.
//
// We create a ClDialog object using the "AboutBox" resource (see
// P2IDEMO.rc), and invoke it.
//
void CMainWindow::OnAbout()
{
 // MessageBoxA("Test", TEXT("P-2-I OnAbout"), MB_OK);

	CDialog about(IDD_ABOUTBOX);
	about.DoModal();
}

// CMainWindow message map:
// Associate messages with member functions.
//
// It is implied that the ON_WM_PAINT macro expects a member function
// "void OnPaint()".
//
// It is implied that members connected with the ON_COMMAND macro
// receive no arguments and are void of return type, e.g., "void OnAbout()".
//
BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWindow )
	ON_WM_PAINT()
	ON_REGISTERED_MESSAGE (uiPAM_IMAGE_CREATED, OnUserTrapped )
	ON_COMMAND(ID_APP_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTheApp

// InitInstance:
// When any CTheApp object is created, this member function is automatically
// called.  Any data may be set up at this point.
//
// Also, the main window of the application should be created and shown here.
// Return TRUE if the initialization is successful.
//
// My internal _assert function.
void _assert(LPCTSTR szExp, LPCTSTR szFile, UINT uLine) {
	TCHAR szBuf[500];
	int n;

	_stprintf(szBuf, 
		__TEXT("File: %s, Line %d\nExp: %s\n\nContinue Execution?"),
		szFile, uLine, szExp);
	n = MessageBox(GetFocus(), szBuf, 
		__TEXT("Assertion Failure"), MB_YESNO);
	if (n == IDNO) 
		ExitProcess(0);
}

 #define assert_(exp, file, line)		(_assert(__TEXT(exp), __TEXT(file), line), 0)
#define assert(exp)	(void)( (exp) || (assert_(#exp, __FILE__, __LINE__)))


BOOL CTheApp::InitInstance()
{
	TRACE0("CTheApp::InitInstance\n");

	Enable3dControls(); // use 3d controls in dialogs

	m_pMainWnd = new CMainWindow;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	g_hInst = m_hInstance;

	return TRUE;
}
